--- iksemel-1.2/src/stream.c	2004-07-30 18:28:27.000000000 +0200
+++ iksemel-1.2-new/src/stream.c	2007-06-02 01:09:17.000000000 +0200
@@ -31,6 +31,7 @@
 	char *auth_username;
 	char *auth_pass;
 #ifdef HAVE_GNUTLS
+	int timeout;
 	gnutls_session sess;
 	gnutls_certificate_credentials cred;
 #endif
@@ -54,9 +55,17 @@
 {
 	struct stream_data *data = iks_user_data (prs);
 	int ret;
+	
+	ret = data->trans->recv (data->sock, buffer, len, data->timeout);
+
+	switch (ret) {
+	case -1: 
+		return (size_t) -1;
+	case 0:
+		errno = EAGAIN;
+		return (size_t) -1;
+	}
 
-	ret = data->trans->recv (data->sock, buffer, len, -1);
-	if (ret == -1) return (size_t) -1;
 	return ret;
 }
 
@@ -90,6 +99,8 @@
 	gnutls_transport_set_push_function (data->sess, (gnutls_push_func) tls_push);
 	gnutls_transport_set_pull_function (data->sess, (gnutls_pull_func) tls_pull);
 	gnutls_transport_set_ptr (data->sess, data->prs);
+	gnutls_transport_set_lowat (data->sess, 0);
+	data->timeout = 1;
 
 	ret = gnutls_handshake (data->sess);
 	if (ret != 0) {
@@ -449,6 +460,8 @@
 	struct stream_data *data = iks_user_data (prs);
 	int len, ret;
 
+	data->timeout = timeout;
+
 	while (1) {
 #ifdef HAVE_GNUTLS
 		if (data->flags & SF_SECURE) {
@@ -458,8 +471,8 @@
 		{
 			len = data->trans->recv (data->sock, data->buf, NET_IO_BUF_SIZE - 1, timeout);
 		}
+		if (len == 0 || len == GNUTLS_E_AGAIN) break;
 		if (len < 0) return IKS_NET_RWERR;
-		if (len == 0) break;
 		data->buf[len] = '\0';
 		if (data->logHook) data->logHook (data->user_data, data->buf, len, 1);
 		ret = iks_parse (prs, data->buf, len, 0);
